/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2015 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief LPC82X DMA ûļ
 * \sa am_hwconf_lpc82x_dma.c
 *
 * \internal
 * \par Modification history
 * - 1.01 15-12-08  mem,modified.
 * - 1.00 15-07-12  win, first implementation.
 * \endinternal
 */
#include "ametal.h"
#include "lpc82x_regbase.h"
#include "am_lpc82x_dma.h"
#include "amhw_lpc82x_dma.h"
#include "amhw_lpc82x_clk.h"

/**
 * \addtogroup am_if_src_hwconf_lpc82x_dma
 * \copydoc am_hwconf_lpc82x_dma.c
 * @{
 */

/**
 * \brief ʹõDMAͨ
 *
 *        ĬʹеDMAͨûԸʵʹͨ
 *        ĴֵDMAڴռ
 * \note  ҪʹDMA,ֵӦΪ1DMAʼɹ
 */
#define __DMA_CHAN_USE_COUNT    AMHW_LPC82X_DMA_CHAN_CNT

 /**
 * \brief DMA ƽ̨ʼ
 */
static void __lpc82x_dma_plfm_init (void)
{
    amhw_lpc82x_clk_periph_enable(AMHW_LPC82X_CLK_DMA);
}

/**
 * \brief DMA ƽ̨ʼ
 */
static void __lpc82x_dma_plfm_deinit (void)
{
    amhw_lpc82x_clk_periph_disable(AMHW_LPC82X_CLK_DMA);
}

/** \brief ӳ */
static uint8_t __g_dam_controller_map[AMHW_LPC82X_DMA_CHAN_CNT];

/** \brief ڴ */
static am_lpc82x_dma_controller_t __g_dma_controller[__DMA_CHAN_USE_COUNT];


/** \brief DMA ͨб512ֽڶ */
static __attribute__((aligned(512))) am_lpc82x_dma_xfer_desc_t \
                                __g_dma_xfer_tab[AMHW_LPC82X_DMA_CHAN_CNT];

/** \brief DMA 豸Ϣ */
static const am_lpc82x_dma_devinfo_t __g_dma_devinfo = {
    LPC82X_DMA_BASE,               /**< \brief DMAĴĻַ             */
    LPC82X_INMUX_BASE,             /**< \brief INMUXĴĻַ           */
    &__g_dam_controller_map[0],    /**< \brief ָӳָ        */
    &__g_dma_controller[0],        /**< \brief ָڴָ          */
    &__g_dma_xfer_tab[0],          /**< \brief ַ512ֽڶ */
    __DMA_CHAN_USE_COUNT,          /**< \brief ʹõDMAͨ             */
    INUM_DMA,                      /**< \brief DMAжϺ                     */

    __lpc82x_dma_plfm_init,        /**< \brief ƽ̨ʼ                */
    __lpc82x_dma_plfm_deinit,      /**< \brief ƽ̨ʼ              */
};

/** \brief DMA豸ʵ */
static am_lpc82x_dma_dev_t __g_dma_dev;

/** \brief DMA ʵʼ */
int am_lpc82x_dma_inst_init (void)
{
    return am_lpc82x_dma_init(&__g_dma_dev, &__g_dma_devinfo);
}

/** \brief DMA ʵʼ */
void am_lpc82x_dma_inst_deinit (void)
{
    am_lpc82x_dma_deinit();
}

/**
 * @}
 */

/* end of file */
