/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2015 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief LPC82x  ʵʼ
 *
 * 豸I2CSPIADC...ʵʼڱͷļʹʵ
 * ʼɻһľȻʹصĽӿںв
 *
 * \sa am_lpc82x_inst_init.h
 * \internal
 * \par Modification history
 * - 1.00 15-12-11  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_LPC82X_INST_INIT_H
#define __AM_LPC82X_INST_INIT_H

#include "am_lpc_sct.h"
#include "ametal.h"
#include "am_adc.h"
#include "am_crc.h"
#include "am_i2c.h"
#include "am_timer.h"
#include "am_cap.h"
#include "am_pwm.h"
#include "am_wdt.h"
#include "am_spi.h"
#include "am_uart.h"
#include "am_zm516x.h"
#include "am_hwconf_miniport_zlg72128.h"
#include "am_hwconf_miniport_595.h"
#include "am_hwconf_led_gpio.h"
#include "am_hwconf_key_gpio.h"
#include "am_hwconf_miniport_view.h"
#include "am_hwconf_miniport_led.h"
#include "am_hwconf_miniport_key.h"
#include "am_hwconf_miniport_view_key.h"
#include "am_hwconf_lm75.h"

/**
 * \addtogroup am_if_lpc82x_inst_init
 * \copydoc am_lpc82x_inst_init.h
 * @{
 */

/**
 * \brief  CLK ʵʼʼϵͳʱ
 * \retval AM_OK : ʱӳɹʼ
 * \note ʱӽΪ⣬޽ʼ
 */
int am_lpc82x_clk_inst_init (void);


/**
 * \brief  ADC0 жϷʵʼADC׼
 * \return ADC׼ΪNULLʼʧ
 */
am_adc_handle_t am_lpc82x_adc0_int_inst_init (void);

/**
 * \brief ADC0 жʵʼ
 * \param[in] handle : ͨ am_lpc82x_adc0_inst_init() õADC
 * \return 
 */
void am_lpc82x_adc0_int_inst_deinit (am_adc_handle_t handle);


/**
 * \brief  ADC0 dmaʵʼADC׼
 * \return ADC׼ΪNULLʼʧ
 */
am_adc_handle_t am_lpc82x_adc0_dma_inst_init (void);

/**
 * \brief ADC0 dmaʵʼ
 * \param[in] handle : ͨ am_lpc82x_adc0_inst_init() õADC
 * \return 
 */
void am_lpc82x_adc0_dma_inst_deinit (am_adc_handle_t handle);


/**
 * \brief  CRC ʵʼCRC׼
 * \return CRC׼ΪNULLʼʧ
 */
am_crc_handle_t am_lpc82x_crc_inst_init (void);

/**
 * \brief CRC ʵʼ
 * \param[in] handle : ͨ am_lpc82x_crc_inst_init() õCRC
 * \return 
 */
void am_lpc82x_crc_inst_deinit (am_crc_handle_t handle);

/**
 * \brief  DMA ʵʼ
 * \retval AM_OK    : ʼɹ
 */
int am_lpc82x_dma_inst_init (void);

/**
 * \brief DMA ʵʼ
 * \return 
 */
void am_lpc82x_dma_inst_deinit (void);

/**
 * \brief  GPIO ʵʼ
 * \retval AM_OK    : ʼɹ
 */
int am_lpc82x_gpio_inst_init (void);

/**
 * \brief GPIO ʵʼ
 * \return 
 */
void am_lpc82x_gpio_inst_deinit (void);


/**
 * \brief  I2C0 ʵʼI2C׼
 * \return I2C׼ΪNULLʼʧ
 */
am_i2c_handle_t am_lpc82x_i2c0_inst_init (void);

/**
 * \brief I2C0 ʵʼ
 * \param[in] handle : ͨ am_lpc82x_i2c0_inst_init() õI2C
 * \return 
 */
void am_lpc82x_i2c0_inst_deinit (am_i2c_handle_t handle);

/**
 * \brief  I2C1 ʵʼI2C׼
 * \return I2C׼ΪNULLʼʧ
 */
am_i2c_handle_t am_lpc82x_i2c1_inst_init (void);

/**
 * \brief I2C1 ʵʼ
 * \param[in] handle : ͨ am_lpc82x_i2c1_inst_init() õI2C
 * \return 
 */
void am_lpc82x_i2c1_inst_deinit (am_i2c_handle_t handle);

/**
 * \brief  I2C2 ʵʼI2C׼
 * \return I2C׼ΪNULLʼʧ
 */
am_i2c_handle_t am_lpc82x_i2c2_inst_init (void);

/**
 * \brief I2C2 ʵʼ
 * \param[in] handle : ͨ am_lpc82x_i2c2_inst_init() õI2C
 * \return 
 */
void am_lpc82x_i2c2_inst_deinit (am_i2c_handle_t handle);


/**
 * \brief  I2C3 ʵʼI2C׼
 * \return I2C׼ΪNULLʼʧ
 */
am_i2c_handle_t am_lpc82x_i2c3_inst_init (void);

/**
 * \brief I2C3 ʵʼ
 * \param[in] handle : ͨ am_lpc82x_i2c3_inst_init() õI2C
 * \return 
 */
void am_lpc82x_i2c3_inst_deinit (am_i2c_handle_t handle);

/**
 * \brief  жʵʼʼж
 * \retval AM_OKΪʵɹʧ
 */
int am_lpc82x_nvic_inst_init (void);

/**
 * \brief  жʵʼ
 */
void am_lpc82x_nvic_inst_deinit (void);

/**
 * \brief  MRT ʵʼMRT׼
 * \return Timer׼ΪNULLʼʧ
 */
am_timer_handle_t am_lpc82x_mrt_inst_init (void);

/**
 * \brief MRT ʵʼ
 * \param[in] handle : ͨ am_lpc82x_mrt_inst_init() õTimer
 * \return 
 */
void am_lpc82x_mrt_inst_deinit (am_timer_handle_t handle);

/**
 * \brief  SCT0 ʵʼSCT׼
 * \return SCT׼ΪNULLʼʧ
 */
am_lpc_sct_handle_t am_lpc82x_sct0_inst_init (void);

/**
 * \brief SCT0 ʵʼ
 * \param[in] handle : ͨ am_lpc82x_sct0_inst_init() õSCT
 * \return 
 */
void am_lpc82x_sct0_inst_deinit (am_lpc_sct_handle_t handle);

/**
 * \brief  SCT0 CAP ʵʼCAP׼
 * \return CAP׼ΪNULLʼʧ
 */
am_cap_handle_t am_lpc82x_sct0_cap_inst_init (void);

/**
 * \brief SCT0 CAP ʵʼ
 * \param[in] handle : ͨ am_lpc82x_sct0_cap_inst_init() õCAP
 * \return 
 */
void am_lpc82x_sct0_cap_inst_deinit (am_cap_handle_t handle);

/**
 * \brief  SCT0 PWM ʵʼPWM׼
 * \return PWM׼ΪNULLʼʧ
 */
am_pwm_handle_t am_lpc82x_sct0_pwm_inst_init (void);

/**
 * \brief SCT0 PWM ʵʼ
 * \param[in] handle : ͨ am_lpc82x_sct0_pwm_inst_init() õPWM
 * \return 
 */
void am_lpc82x_sct0_pwm_inst_deinit (am_pwm_handle_t handle);


/**
 * \brief  SCT0 Timer ʵʼTimer׼
 * \return Timer׼ΪNULLʼʧ
 */
am_timer_handle_t am_lpc82x_sct0_timing_inst_init (void);

/**
 * \brief SCT0 Timer ʵʼ
 * \param[in] handle : ͨ am_lpc82x_sct0_timing_inst_init() õTimer
 * \return 
 */
void am_lpc82x_sct0_timing_inst_deinit (am_timer_handle_t handle);

/**
 * \brief  SPI0 жϷʽʵʼSPI׼
 * \return SPI׼ΪNULLʼʧ
 */
am_spi_handle_t am_lpc82x_spi0_int_inst_init (void);

/**
 * \brief SPI0 жϷʽʵʼ
 * \param[in] handle : ͨ am_lpc82x_spi0_int_inst_init() õSPI
 * \return 
 */
void am_lpc82x_spi0_int_inst_deinit (am_spi_handle_t handle);

/**
 * \brief  SPI1 жϷʽʵʼSPI׼
 * \return SPI׼ΪNULLʼʧ
 */
am_spi_handle_t am_lpc82x_spi1_int_inst_init (void);

/**
 * \brief SPI1 жϷʽʵʼ
 * \param[in] handle : ͨ am_lpc82x_spi1_int_inst_init() õSPI
 * \return 
 */
void am_lpc82x_spi1_int_inst_deinit (am_spi_handle_t handle);

/**
 * \brief  SPI0 DMAʽʵʼSPI׼
 * \return SPI׼ΪNULLʼʧ
 */
am_spi_handle_t am_lpc82x_spi0_dma_inst_init (void);

/**
 * \brief SPI0 DMAʽʵʼ
 * \param[in] handle : ͨ am_lpc82x_spi0_dma_inst_init() õSPI
 * \return 
 */
void am_lpc82x_spi0_dma_inst_deinit (am_spi_handle_t handle);

/**
 * \brief  SPI1 DMAʽʵʼSPI׼
 * \return SPI׼ΪNULLʼʧ
 */
am_spi_handle_t am_lpc82x_spi1_dma_inst_init (void);

/**
 * \brief SPI1 DMAʽʵʼ
 * \param[in] handle : ͨ am_lpc82x_spi1_dma_inst_init() õSPI
 * \return 
 */
void am_lpc82x_spi1_dma_inst_deinit (am_spi_handle_t handle);


/** \brief SYSTICK ʵʼTimer׼ */
am_timer_handle_t am_lpc82x_systick_inst_init (void);

/** \brief SYSTICK ʵʼ */
void am_lpc82x_systick_inst_deinit (am_timer_handle_t handle);

/**
 * \brief  USART0 ʵʼUART׼
 * \return UART׼ΪNULLʼʧ
 */
am_uart_handle_t am_lpc82x_usart0_inst_init (void);

/**
 * \brief USART0 ʵʼ
 * \param[in] handle : ͨ am_lpc82x_usart0_inst_init() õUART
 * \return 
 */
void am_lpc82x_usart0_inst_deinit (am_uart_handle_t handle);


/**
 * \brief  USART1 ʵʼUART׼
 * \return UART׼ΪNULLʼʧ
 */
am_uart_handle_t am_lpc82x_usart1_inst_init (void);

/**
 * \brief     USART1 ʵʼ
 * \param[in] handle : ͨ am_lpc82x_usart1_inst_init() õUART
 * \return 
 */
void am_lpc82x_usart1_inst_deinit (am_uart_handle_t handle);

/**
 * \brief  USART2 ʵʼUART׼
 * \return UART׼ΪNULLʼʧ
 */
am_uart_handle_t am_lpc82x_usart2_inst_init (void);

/**
 * \brief USART2 ʵʼ
 * \param[in] handle : ͨ am_lpc82x_usart2_inst_init() õUART
 * \return 
 */
void am_lpc82x_usart2_inst_deinit (am_uart_handle_t handle);

/**
 * \brief  WKT ʵʼTimer׼
 * \return Timer׼ΪNULLʼʧ
 */
am_timer_handle_t am_lpc82x_wkt_inst_init (void);

/**
 * \brief WKT ʵʼ
 * \param[in] handle : ͨ am_lpc82x_wkt_inst_init() õTimer
 * \return 
 */
void am_lpc82x_wkt_inst_deinit (am_timer_handle_t handle);


/**
 * \brief  WWDT ʵʼWDT׼
 * \return WDT׼ΪNULLʼʧ
 */
am_wdt_handle_t am_lpc82x_wwdt_inst_init (void);

/**
 * \brief WWDT ʵʼ
 * \param[in] handle : ͨ am_lpc82x_wwdt_inst_init() õWDT
 * \return 
 */
void am_lpc82x_wwdt_inst_deinit (am_wdt_handle_t handle);

/**
 * \brief ZM516XʵʼZM516Xģ׼
 *
 * \return ZM516Xģ׼
 */
am_zm516x_handle_t am_zm516x_inst_init (void);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif  /* __AM_LPC82X_INST_INIT_H */

/* end of file */
