/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2015 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief LPC82X SCT0 ڶʱܵûļ
 * \sa am_hwconf_lpc82x_sct0_timing.c
 *
 * \internal
 * \par Modification history
 * - 1.01 15-12-09  hgo, modified.
 * - 1.00 15-07-07  oce, first implementation.
 * \endinternal
 */
#include "ametal.h"
#include "am_lpc82x.h"
#include "amhw_lpc82x_clk.h"
#include "am_lpc_sct_timing.h"

/**
 * \addtogroup am_if_src_hwconf_lpc82x_sct0_timing
 * \copydoc am_hwconf_lpc82x_sct0_timing.c
 * @{
 */

/** \brief SCT0 ƽ̨ʼ */
static void __lpc82x_sct0_timing_plfm_init (void)
{
    amhw_lpc82x_clk_periph_enable(AMHW_LPC82X_CLK_SCT);
    amhw_lpc82x_syscon_periph_reset(AMHW_LPC82X_RESET_SCT);
}

/** \brief SCT0ƽ̨ʼ */
static void __lpc82x_sct0_timing_plfm_deinit (void)
{
    amhw_lpc82x_syscon_periph_reset (AMHW_LPC82X_RESET_SCT);
    amhw_lpc82x_clk_periph_disable(AMHW_LPC82X_CLK_SCT);
}

/** \brief SCT 豸Ϣ */
static const am_lpc_sct_timing_devinfo_t  __g_sct0_timing_devinfo = {
    LPC82X_SCT0_BASE,                 /**< \brief SCT0ĴĻַ */
    INUM_SCT0,                        /**< \brief SCT0жϱ           */
    CLK_SCT,                          /**< \brief SCT0ʱӱ           */
    AM_LPC_SCT_TIMING_2_16BIT,        /**< \brief SCT216-bitʱ */
    __lpc82x_sct0_timing_plfm_init,   /**< \brief ƽ̨ʼ         */
    __lpc82x_sct0_timing_plfm_deinit, /**< \brief ƽ̨ʼ       */
};

/** \brief SCT豸 */
static am_lpc_sct_timing_dev_t  __g_sct0_timing_dev;

/** \brief SCT0 Timer ʵʼTimer׼ */
am_timer_handle_t am_lpc82x_sct0_timing_inst_init (void)
{
    return am_lpc_sct_timing_init(&__g_sct0_timing_dev,
                                   &__g_sct0_timing_devinfo);
}

/** \brief SCT0 Timer ʵʼ */
void am_lpc82x_sct0_timing_inst_deinit (am_timer_handle_t handle)
{
    am_lpc_sct_timing_deinit((am_lpc_sct_timing_dev_t *)handle);
}

/**
 * @}
 */

/* end of file */
