/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief RX8025T ļ
 * \sa am_hwconf_rx8025t.c
 *
 * \internal
 * \par Modification history
 * - 1.00 17-07-13  tee, first implementation.
 * \endinternal
 */
#include "ametal.h"
#include "am_lpc82x_inst_init.h"
#include "lpc82x_pin.h"
#include "am_rx8025t.h"
#include "am_time.h"
#include "am_alarm_clk.h"

/**
 * \addtogroup am_if_src_hwconf_rx8025t
 * \copydoc am_hwconf_rx8025t.c
 * @{
 */

/*******************************************************************************
    RX8025T ʵʼʹоƬ⹦ܣ
*******************************************************************************/

static am_rx8025t_dev_t    __g_rx8025t_dev; /* һrx8025tʵ */

static const am_rx8025t_devinfo_t  __g_rx8025t_devinfo = {  /* RX8025TʵϢ */
    PIO0_1,                                                 /* INTӦIOź */
    PIO0_10,                                                /* CLK_ENӦIOź */
};

am_rx8025t_handle_t am_rx8025t_inst_init (void)
{
    am_i2c_handle_t i2c_handle = am_lpc82x_i2c1_inst_init(); /* ȡI2C1ʵ */
    static am_rx8025t_handle_t rx8025t_handle = NULL;

    if (rx8025t_handle == NULL) {
        rx8025t_handle = am_rx8025t_init(&__g_rx8025t_dev,
                                         &__g_rx8025t_devinfo,
                                          i2c_handle);
    }

    return rx8025t_handle;
}

/*******************************************************************************
    RX8025T ʵʼ ʹͨõRTCܣ
*******************************************************************************/

static am_rtc_serv_t      __g_rx8025t_rtc; /* һ RTC ʵ */

am_rtc_handle_t am_rx8025t_rtc_inst_init(void)
{
    am_rx8025t_handle_t rx8025t_handle = am_rx8025t_inst_init();

    return am_rx8025t_rtc_init(rx8025t_handle, &__g_rx8025t_rtc);
}

/*******************************************************************************
    RX8025T ʵʼ ʹͨõӹܣ
*******************************************************************************/

static am_alarm_clk_serv_t  __g_rx8025t_alarm_clk; /* һʵ */

am_alarm_clk_handle_t  am_rx8025t_alarm_clk_inst_init(void)
{
    am_rx8025t_handle_t  rx8025t_handle = am_rx8025t_inst_init();
    return am_rx8025t_alarm_clk_init (rx8025t_handle, &__g_rx8025t_alarm_clk);
}

/*******************************************************************************
    RX8025T ʵʼ RX8025Tϵͳʱ䣩
*******************************************************************************/

#define __UPDATE_SYSCLK_NS   1000000 /* ÿ1ms(1000000ns)ϵͳʱӸһϵͳʱֵ */
#define __UPDATE_RTC_S       10      /* ÿ10sRTCһϵͳʱֵ */

int am_rx8025t_time_inst_init(void)
{
    am_rtc_handle_t rtc_handle = am_rx8025t_rtc_inst_init();

    return am_time_init(rtc_handle,
                        __UPDATE_SYSCLK_NS,
                        __UPDATE_RTC_S);
}

/**
 * @}
 */

/* end of file */
